#[doc = "Register `INT_CLK_CTL` reader"]
pub struct R(crate::R<INT_CLK_CTL_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<INT_CLK_CTL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<INT_CLK_CTL_SPEC>> for R {
    fn from(reader: crate::R<INT_CLK_CTL_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `INT_CLK_CTL` writer"]
pub struct W(crate::W<INT_CLK_CTL_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<INT_CLK_CTL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<INT_CLK_CTL_SPEC>> for W {
    fn from(writer: crate::W<INT_CLK_CTL_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `INT_CLK_ENABLE` reader - This bit enables the interrupt synchronizer in the UDB interface. It needs to be set whenever UDB/DSI interrupts are used. Disabling the interrupt synchronizer saves power in Active/Sleep mode."]
pub struct INT_CLK_ENABLE_R(crate::FieldReader<bool, bool>);
impl INT_CLK_ENABLE_R {
    pub(crate) fn new(bits: bool) -> Self {
        INT_CLK_ENABLE_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for INT_CLK_ENABLE_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `INT_CLK_ENABLE` writer - This bit enables the interrupt synchronizer in the UDB interface. It needs to be set whenever UDB/DSI interrupts are used. Disabling the interrupt synchronizer saves power in Active/Sleep mode."]
pub struct INT_CLK_ENABLE_W<'a> {
    w: &'a mut W,
}
impl<'a> INT_CLK_ENABLE_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | (value as u8 & 0x01);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - This bit enables the interrupt synchronizer in the UDB interface. It needs to be set whenever UDB/DSI interrupts are used. Disabling the interrupt synchronizer saves power in Active/Sleep mode."]
    #[inline(always)]
    pub fn int_clk_enable(&self) -> INT_CLK_ENABLE_R {
        INT_CLK_ENABLE_R::new((self.bits & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - This bit enables the interrupt synchronizer in the UDB interface. It needs to be set whenever UDB/DSI interrupts are used. Disabling the interrupt synchronizer saves power in Active/Sleep mode."]
    #[inline(always)]
    pub fn int_clk_enable(&mut self) -> INT_CLK_ENABLE_W {
        INT_CLK_ENABLE_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Interrupt Synchronizer Clock Control\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [int_clk_ctl](index.html) module"]
pub struct INT_CLK_CTL_SPEC;
impl crate::RegisterSpec for INT_CLK_CTL_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [int_clk_ctl::R](R) reader structure"]
impl crate::Readable for INT_CLK_CTL_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [int_clk_ctl::W](W) writer structure"]
impl crate::Writable for INT_CLK_CTL_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets INT_CLK_CTL to value 0"]
impl crate::Resettable for INT_CLK_CTL_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
